<?php
/*
 * Plugin Name: iThemes Exchange - Store Exporter
 * Plugin URI: http://www.visser.com.au/exchange/plugins/exporter/
 * Description: Export store details out of iThemes Exchange into a CSV-formatted file.
 * Version: 1.2
 * Author: Visser Labs
 * Author URI: http://www.visser.com.au/about/
 * License: GPL2
 * iThemes Package: exchange-addon-exporter

 * Installation:
 * 1. Download and unzip the latest release zip file.
 * 2. If you use the WordPress Plugin uploader to install this plugin skip to step 4.
 * 3. Upload the entire plugin directory to your `/wp-content/plugins/` directory.
 * 4. Activate the plugin through the 'Plugins' menu in WordPress Administration.
 *
*/

/**
 * This registers our plugin as a product exporter add-on
 *
 * @since 1.0
 *
 * @return void
*/
function it_exchange_exporter_register_addon() {

  $options = array(
      'name'              => __( 'Store Exporter', 'exchange-addon-exporter' ),
      'description'       => __( 'Adds the ability to export store details out of iThemes Exchange into a CSV-formatted file.', 'exchange-addon-exporter' ),
      'author'            => 'Visser Labs',
      'author_url'        => 'http://www.visser.com.au/about/',
      'icon'              => ITUtility::get_url_from_file( dirname( __FILE__ ) . '/images/exporter50px.png' ),
      'file'              => dirname( __FILE__ ) . '/init.php',
      'category'          => 'admin',
      'settings-callback' => 'it_exchange_exporter_addon_settings_callback',    
  );
  it_exchange_register_addon( 'exporter', $options );
  
}
add_action( 'it_exchange_register_addons', 'it_exchange_exporter_register_addon' );

/**
 * Loads the translation data for WordPress
 *
 * @uses load_plugin_textdomain()
 * @since 1.0
 * @return void
*/
function it_exchange_exporter_i18n() {

	load_plugin_textdomain( 'exchange-addon-exporter', false, dirname( plugin_basename( __FILE__ ) ) . '/languages' );

}
add_action( 'plugins_loaded', 'it_exchange_exporter_i18n' );
?>