<?php
include_once( ITE_CE_PATH . 'includes/functions-products.php' );

include_once( ITE_CE_PATH . 'includes/formatting.php' );
include_once( ITE_CE_PATH . 'includes/functions-csv.php' );

if( is_admin() ) {

	/* Start of: WordPress Administration */

	function it_exchange_exporter_detect_non_exchange_install() {

		if( !it_exchange_is_woo_activated() && ( it_exchange_is_jigo_activated() || it_exchange_is_wpsc_activated() ) ) {
			$troubleshooting_url = 'http://www.visser.com.au/documentation/store-exporter-deluxe/usage/';
			$message = __( 'We have detected another e-Commerce Plugin than iThemes Exchange activated, please check that you are using Store Exporter Deluxe for the correct platform.', 'exchange-addon-exporter' ) . '<a href="' . $troubleshooting_url . '" target="_blank">' . __( 'Need help?', 'exchange-addon-exporter' ) . '</a>';
			it_exchange_exporter_admin_notice( $message, 'error', 'plugins.php' );
		}
		it_exchange_exporter_plugin_page_notices();

	}

	function it_exchange_exporter_plugin_page_notices() {

		global $pagenow;

		if( $pagenow == 'plugins.php' ) {
			if( it_exchange_is_jigo_activated() || it_exchange_is_wpsc_activated() ) {
				$r_plugins = array(
					'exchange-addon-exporter/exporter.php'
				);
				$i_plugins = get_plugins();
				foreach( $r_plugins as $path ) {
					if( isset( $i_plugins[$path] ) ) {
						add_action( 'after_plugin_row_' . $path, 'it_exchange_exporter_plugin_page_notice', 10, 3 );
						break;
					}
				}
			}
		}
	}

	function it_exchange_exporter_plugin_page_notice( $file, $data, $context ) {

		if( is_plugin_active( $file ) ) { ?>
<tr class='plugin-update-tr su-plugin-notice'>
	<td colspan='3' class='plugin-update colspanchange'>
		<div class='update-message'>
			<?php printf( __( '%1$s is intended to be used with a iThemes Exchange store, please check that you are using Store Exporter with the correct e-Commerce platform.', 'exchange-addon-exporter' ), $data['Name'] ); ?>
		</div>
	</td>
</tr>
<?php
		}

	}

	// Display admin notice on screen load
	function it_exchange_exporter_admin_notice( $message = '', $priority = 'updated', $screen = '' ) {

		if( empty( $priority ) )
			$priority = 'updated';
		if( !empty( $message ) )
			add_action( 'admin_notices', it_exchange_exporter_admin_notice_html( $message, $priority, $screen ) );

	}

	// HTML template for admin notice
	function it_exchange_exporter_admin_notice_html( $message = '', $priority = 'updated', $screen = '' ) {

		// Display admin notice on specific screen
		if( !empty( $screen ) ) {
			global $pagenow;
			if( $pagenow <> $screen )
				return;
		} ?>
<div id="message" class="<?php echo $priority; ?>">
	<p><?php echo $message; ?></p>
</div>
<?php

	}

	// Add Store Export to WordPress Administration menu
	function it_exchange_exporter_menu_item() {

		add_submenu_page( 'it-exchange', __( 'Store Exporter', 'exchange-addon-exporter' ), __( 'Store Export', 'exchange-addon-exporter' ), 'manage_options', 'it-exchange-exporter', 'it_exchange_exporter_html_page' );

	}
	add_action( 'admin_menu', 'it_exchange_exporter_menu_item', 11 );

	// HTML template for header prompt on Store Exporter screen
	function it_exchange_exporter_support_donate() {

		$output = '';
		$show = true;
		if( function_exists( 'it_exchange_vl_we_love_your_plugins' ) ) {
			if( in_array( ITE_CE_DIRNAME, it_exchange_vl_we_love_your_plugins() ) )
				$show = false;
		}
		if( function_exists( 'it_exchange_exporter_deluxe_admin_init' ) )
			$show = false;
		if( $show ) {
			$donate_url = 'http://www.visser.com.au/#donations';
			$rate_url = 'http://wordpress.org/support/view/plugin-reviews/' . ITE_CE_DIRNAME;
			$output = '
	<div id="support-donate_rate" class="support-donate_rate">
		<p>' . sprintf( __( '<strong>Like this Plugin?</strong> %s and %s.', 'exchange-addon-exporter' ), '<a href="' . $donate_url . '" target="_blank">' . __( 'Donate to support this Plugin', 'exchange-addon-exporter' ) . '</a>', '<a href="' . add_query_arg( array( 'rate' => '5' ), $rate_url ) . '#postform" target="_blank">rate / review us on WordPress.org</a>' ) . '</p>
	</div>
';
		}
		echo $output;

	}

	// Saves the state of Export fields for next export
	function it_exchange_exporter_save_fields( $type, $fields = array() ) {

		if( $type && !empty( $fields ) )
			it_exchange_exporter_update_option( $type . '_fields', $fields );

	}

	// Add Store Export to filter types on the WordPress Media screen
	function it_exchange_exporter_add_post_mime_type( $post_mime_types = array() ) {

		$post_mime_types['text/csv'] = array( __( 'Store Exports', 'exchange-addon-exporter' ), __( 'Manage Store Exports', 'exchange-addon-exporter' ), _n_noop( 'Store Export <span class="count">(%s)</span>', 'Store Exports <span class="count">(%s)</span>' ) );
		return $post_mime_types;

	}
	add_filter( 'post_mime_types', 'it_exchange_exporter_add_post_mime_type' );

	// In-line display of CSV file and export details when viewed via WordPress Media screen
	function it_exchange_exporter_read_csv_file( $post = null ) {

		if( !$post ) {
			if( isset( $_GET['post'] ) )
				$post = get_post( $_GET['post'] );
		}

		if( $post->post_type != 'attachment' )
			return false;

		if( $post->post_mime_type != 'text/csv' )
			return false;

		$filename = $post->post_name;
		$filepath = get_attached_file( $post->ID );
		$contents = __( 'No export entries were found, please try again with different export filters.', 'exchange-addon-exporter' );
		if( file_exists( $filepath ) ) {
			$handle = fopen( $filepath, "r" );
			$contents = stream_get_contents( $handle );
			fclose( $handle );
		} else {
			// This resets the _wp_attached_file Post meta key to the correct value
			update_attached_file( $post->ID, $post->guid );
			// Try grabbing the file contents again
			$filepath = get_attached_file( $post->ID );
			if( file_exists( $filepath ) ) {
				$handle = fopen( $filepath, "r" );
				$contents = stream_get_contents( $handle );
				fclose( $handle );
			}
		}
		if( !empty( $contents ) )
			include_once( ITE_CE_PATH . 'templates/admin/it_exchange-admin_ce-media_csv_file.php' );

		$export_type = get_post_meta( $post->ID, '_exchange_export_type', true );
		$columns = get_post_meta( $post->ID, '_exchange_columns', true );
		$rows = get_post_meta( $post->ID, '_exchange_rows', true );
		$start_time = get_post_meta( $post->ID, '_exchange_start_time', true );
		$end_time = get_post_meta( $post->ID, '_exchange_end_time', true );
		$idle_memory_start = get_post_meta( $post->ID, '_exchange_idle_memory_start', true );
		$data_memory_start = get_post_meta( $post->ID, '_exchange_data_memory_start', true );
		$data_memory_end = get_post_meta( $post->ID, '_exchange_data_memory_end', true );
		$idle_memory_end = get_post_meta( $post->ID, '_exchange_idle_memory_end', true );
		include_once( ITE_CE_PATH . 'templates/admin/it_exchange-admin_ce-media_export_details.php' );

	}
	add_action( 'edit_form_after_editor', 'it_exchange_exporter_read_csv_file' );

	// List of Export types used on Store Exporter screen
	function it_exchange_exporter_return_export_types() {

		$export_types = array();
		$export_types['products'] = __( 'Products', 'exchange-addon-exporter' );
		$export_types = apply_filters( 'it_exchange_exporter_export_types', $export_types );
		return $export_types;

	}

	// Returns label of Export type slug used on Store Exporter screen
	function it_exchange_exporter_export_type_label( $export_type = '', $echo = false ) {

		$output = '';
		if( !empty( $export_type ) ) {
			$export_types = it_exchange_exporter_return_export_types();
			if( array_key_exists( $export_type, $export_types ) )
				$output = $export_types[$export_type];
		}
		if( $echo )
			echo $output;
		else
			return $output;

	}

	// Returns number of an Export type prior to export, used on Store Exporter screen
	function it_exchange_exporter_count_posts( $post_type = '' ) {

		if( post_type_exists( $post_type ) ) {
			$posts = wp_count_posts( $post_type );
			if( is_object( $posts ) ) {
				$count = 0;
				$posts = (array)$posts;
				$count = array_sum( $posts );
			} else {
				$count = $posts;
			}
			return $count;
		}

	}

	function it_exchange_exporter_template_header( $title = '' ) { ?>
<div id="profile-page" class="wrap">
	<h2><?php echo $title; ?></h2>
<?php
	}

	function it_exchange_exporter_template_footer() { ?>
</div>
<!-- .wrap -->
<?php
	}

	// HTML active class for the currently selected tab on the Store Exporter screen
	function it_exchange_exporter_admin_active_tab( $tab_name = null, $tab = null ) {

		if( isset( $_GET['tab'] ) && !$tab )
			$tab = $_GET['tab'];
		else if( !isset( $_GET['tab'] ) && it_exchange_exporter_get_option( 'skip_overview', false ) )
			$tab = 'export';
		else
			$tab = 'overview';

		$output = '';
		if( isset( $tab_name ) && $tab_name ) {
			if( $tab_name == $tab )
				$output = ' nav-tab-active';
		}
		echo $output;

	}

	// HTML template for each tab on the Store Exporter screen
	function it_exchange_exporter_tab_template( $tab = '' ) {

		if( !$tab )
			$tab = 'overview';

		switch( $tab ) {

			case 'export':
				$export_type = ( isset( $_POST['dataset'] ) ? $_POST['dataset'] : 'products' );

				$products = it_exchange_exporter_count_posts( 'it_exchange_prod' );

				$product_fields = it_exchange_exporter_get_product_fields();
				$troubleshooting_url = 'http://www.visser.com.au/documentation/store-exporter/usage/';

				// Export options
				$limit_volume = it_exchange_exporter_get_option( 'limit_volume' );
				$offset = it_exchange_exporter_get_option( 'offset' );
				break;

			case 'archive':
				if( isset( $_GET['deleted'] ) ) {
					$message = __( 'Archived export has been deleted.', 'exchange-addon-exporter' );
					it_exchange_exporter_admin_notice( $message );
				}
				if( $files = it_exchange_exporter_get_archive_files() ) {
					foreach( $files as $key => $file )
						$files[$key] = it_exchange_exporter_get_archive_file( $file );
				}
				break;

			case 'settings':
				$options = it_exchange_get_option( 'addon_exporter' );
				$defaults = array(
					'filename' => '%dataset%-export-%date%.csv',
					'delete_csv' => 0,
					'encoding' => 'UTF-8',
					'timeout' => 0,
					'delimiter' => ',',
					'category_separator' => '|',
					'bom' => 1,
					'escape_formatting' => 'all'
				);
				$options = wp_parse_args( $options, $defaults );
				extract( $options, EXTR_SKIP );
				$file_encodings = ( function_exists( 'mb_list_encodings' ) ? mb_list_encodings() : false );
				break;

		}

		if( $tab ) {
			if( file_exists( ITE_CE_PATH . 'templates/admin/it_exchange-admin_ce-export_' . $tab . '.php' ) )
				include_once( ITE_CE_PATH . 'templates/admin/it_exchange-admin_ce-export_' . $tab . '.php' );
		}

	}

	function it_exchange_exporter_export_options_export_format() {

		ob_start(); ?>
<tr>
	<th>
		<label><?php _e( 'Export format', 'exchange-addon-exporter' ); ?></label>
	</th>
	<td>
		<label><input type="radio" name="export_format" value="csv"<?php checked( 'csv', 'csv' ); ?> /> <?php _e( 'CSV', 'exchange-addon-exporter' ); ?> <span class="description"><?php _e( '(Comma separated values)', 'exchange-addon-exporter' ); ?></span></label><br />
		<p class="description"><?php _e( 'Adjust the export format to generate different export file formats.', 'exchange-addon-exporter' ); ?></p>
	</td>
</tr>
<?php
		ob_end_flush();

	}

	// Returns a list of archived exports
	function it_exchange_exporter_get_archive_files() {

		$post_type = 'attachment';
		$meta_key = '_exchange_export_type';
		$args = array(
			'post_type' => $post_type,
			'post_mime_type' => 'text/csv',
			'meta_key' => $meta_key,
			'meta_value' => null,
			'posts_per_page' => -1,
			'cache_results' => false,
			'no_found_rows' => false
		);
		if( isset( $_GET['filter'] ) ) {
			$filter = $_GET['filter'];
			if( !empty( $filter ) )
				$args['meta_value'] = $filter;
		}
		$files = get_posts( $args );
		return $files;

	}

	// Returns an archived export with additional details
	function it_exchange_exporter_get_archive_file( $file = '' ) {

		$wp_upload_dir = wp_upload_dir();
		$file->export_type = get_post_meta( $file->ID, '_exchange_export_type', true );
		$file->export_type_label = it_exchange_exporter_export_type_label( $file->export_type );
		if( empty( $file->export_type ) )
			$file->export_type = __( 'Unassigned', 'exchange-addon-exporter' );
		if( empty( $file->guid ) )
			$file->guid = $wp_upload_dir['url'] . '/' . basename( $file->post_title );
		$file->post_mime_type = get_post_mime_type( $file->ID );
		if( !$file->post_mime_type )
			$file->post_mime_type = __( 'N/A', 'exchange-addon-exporter' );
		$file->media_icon = wp_get_attachment_image( $file->ID, array( 80, 60 ), true );
		if( $author_name = get_user_by( 'id', $file->post_author ) )
			$file->post_author_name = $author_name->display_name;
		$t_time = strtotime( $file->post_date, current_time( 'timestamp' ) );
		$time = get_post_time( 'G', true, $file->ID, false );
		if( ( abs( $t_diff = time() - $time ) ) < 86400 )
			$file->post_date = sprintf( __( '%s ago' ), human_time_diff( $time ) );
		else
			$file->post_date = mysql2date( __( 'Y/m/d' ), $file->post_date );
		unset( $author_name, $t_time, $time );
		return $file;

	}

	// HTML template for displaying the current export type filter on the Archives screen
	function it_exchange_exporter_archives_quicklink_current( $current = '' ) {

		$output = '';
		if( isset( $_GET['filter'] ) ) {
			$filter = $_GET['filter'];
			if( $filter == $current )
				$output = ' class="current"';
		} else if( $current == 'all' ) {
			$output = ' class="current"';
		}
		echo $output;

	}

	// HTML template for displaying the number of each export type filter on the Archives screen
	function it_exchange_exporter_archives_quicklink_count( $type = '' ) {

		$output = '0';
		$post_type = 'attachment';
		$args = array(
			'post_type' => $post_type,
			'meta_key' => '_exchange_export_type',
			'meta_value' => null,
			'numberposts' => -1,
			'cache_results' => false,
			'no_found_rows' => false
		);
		if( $type )
			$args['meta_value'] = $type;
		if( $posts = get_posts( $args ) )
			$output = count( $posts );
		echo $output;

	}

	/* End of: WordPress Administration */

}

/* Start of: Common */

// Export process for CSV file
function it_exchange_exporter_export_dataset( $export_type, &$output = null ) {

	global $export;

	if( $export->export_format == 'csv' ) {
		$output = '';
		if( $export->bom )
			// $output .= chr(239) . chr(187) . chr(191) . '';
			$output .= "\xEF\xBB\xBF";
	}
	$separator = $export->delimiter;
	$export->columns = array();
	set_transient( ITE_CE_PREFIX . '_running', time(), it_exchange_exporter_get_option( 'timeout', MINUTE_IN_SECONDS ) );

	switch( $export_type ) {

		// Products
		case 'products':
			$fields = it_exchange_exporter_get_product_fields( 'summary' );
			if( $export->fields = array_intersect_assoc( $fields, $export->fields ) ) {
				foreach( $export->fields as $key => $field )
					$export->columns[] = it_exchange_exporter_get_product_field( $key );
			}
			$export->data_memory_start = it_exchange_exporter_current_memory_usage();
			if( $products = it_exchange_exporter_get_products( $export->args ) ) {
				$export->total_rows = count( $products );
				$export->total_columns = $size = count( $export->columns );
				if( $export->export_format == 'csv' ) {
					for( $i = 0; $i < $size; $i++ ) {
						if( $i == ( $size - 1 ) )
							$output .= it_exchange_exporter_escape_csv_value( $export->columns[$i], $export->delimiter, $export->escape_formatting ) . "\n";
						else
							$output .= it_exchange_exporter_escape_csv_value( $export->columns[$i], $export->delimiter, $export->escape_formatting ) . $separator;
					}
					unset( $export->columns );
				}
				foreach( $products as $product ) {

					$product = it_exchange_exporter_get_product_data( $product, $export->args );
					foreach( $export->fields as $key => $field ) {
						if( isset( $product->$key ) ) {
							if( is_array( $field ) ) {
								foreach( $field as $array_key => $array_value ) {
									if( !is_array( $array_value ) ) {
										if( $export->export_format == 'csv' )
											$output .= it_exchange_exporter_escape_csv_value( $array_value, $export->delimiter, $export->escape_formatting );
									}
								}
							} else {
								if( $export->export_format == 'csv' )
									$output .= it_exchange_exporter_escape_csv_value( $product->$key, $export->delimiter, $export->escape_formatting );
							}
						}
						if( $export->export_format == 'csv' )
							$output .= $separator;
					}
					if( $export->export_format == 'csv' )
						$output = substr( $output, 0, -1 ) . "\n";
				}
				unset( $products, $product );
			}
			$export->data_memory_end = it_exchange_exporter_current_memory_usage();
			break;

	}
	// Export completed successfully
	delete_transient( ITE_CE_PREFIX . '_running' );
	if( $output ) {
		if( $export->export_format == 'csv' )
			$output = it_exchange_exporter_file_encoding( $output );
		if( ITE_CE_DEBUG )
			set_transient( ITE_CE_PREFIX . '_debug_log', base64_encode( $output ), it_exchange_exporter_get_option( 'timeout', MINUTE_IN_SECONDS ) );
		else
			return $output;
	}

}

// Returns the Post object of the export file saved as an attachment to the WordPress Media library
function it_exchange_exporter_save_file_attachment( $filename = '', $post_mime_type = 'text/csv' ) {

	$output = 0;
	if( !empty( $filename ) ) {
		$post_type = 'exchange-export';
		$args = array(
			'post_title' => $filename,
			'post_type' => $post_type,
			'post_mime_type' => $post_mime_type
		);
		if( $post_ID = wp_insert_attachment( $args, $filename ) )
			$output = $post_ID;
	}
	return $output;

}

// Updates the GUID of the export file attachment to match the correct file URL
function it_exchange_exporter_save_file_guid( $post_ID, $export_type, $upload_url = '' ) {

	add_post_meta( $post_ID, '_exchange_export_type', $export_type );
	if( !empty( $upload_url ) ) {
		$args = array(
			'ID' => $post_ID,
			'guid' => $upload_url
		);
		wp_update_post( $args );
	}

}

// Save critical export details against the archived export
function it_exchange_exporter_save_file_details( $post_ID ) {

	global $export;

	add_post_meta( $post_ID, '_exchange_start_time', $export->start_time );
	add_post_meta( $post_ID, '_exchange_idle_memory_start', $export->idle_memory_start );
	add_post_meta( $post_ID, '_exchange_columns', $export->total_columns );
	add_post_meta( $post_ID, '_exchange_rows', $export->total_rows );
	add_post_meta( $post_ID, '_exchange_data_memory_start', $export->data_memory_start );
	add_post_meta( $post_ID, '_exchange_data_memory_end', $export->data_memory_end );

}

// Update detail of existing archived export
function it_exchange_exporter_update_file_detail( $post_ID, $detail, $value ) {

	if( strstr( $detail, '_exchange_' ) !== false )
		update_post_meta( $post_ID, $detail, $value );

}

function it_exchange_exporter_add_missing_mime_type( $mime_types = array() ) {

	// Add CSV mime type if it has been removed
	if( !isset( $mime_types['csv'] ) )
		$mime_types['csv'] = 'text/csv';
	return $mime_types;

}
add_filter( 'upload_mimes', 'it_exchange_exporter_add_missing_mime_type', 10, 1 );

if( !function_exists( 'it_exchange_exporter_current_memory_usage' ) ) {
	function it_exchange_exporter_current_memory_usage() {

		$output = '';
		if( function_exists( 'memory_get_usage' ) )
			$output = round( memory_get_usage( true ) / 1024 / 1024, 2 );
		return $output;

	}
}

function it_exchange_exporter_get_option( $option = null, $default = false ) {

	$output = '';
	if( isset( $option ) ) {
		if( $storage = get_option( 'it-storage-exchange_addon_exporter', array() ) )
			$output = ( isset( $storage[$option] ) ? $storage[$option] : $default );
	}
	return $output;

}

function it_exchange_exporter_update_option( $option = null, $value = null ) {

	$output = false;
	if( isset( $option ) && isset( $value ) ) {
		$storage = (array)get_option( 'it-storage-exchange_addon_exporter', array() );
		$storage[$option] = $value;
		$output = update_option( 'it-storage-exchange_addon_exporter', $storage );
	}
	return $output;

}

/* End of: Common */
?>