<ul class="subsubsub">
	<li><a href="#general-settings"><?php _e( 'General Settings', 'exchange-addon-exporter' ); ?></a> |</li>
	<li><a href="#csv-settings"><?php _e( 'CSV Settings', 'exchange-addon-exporter' ); ?></a></li>
	<?php do_action( 'it_exchange_exporter_settings_top' ); ?>
</ul>
<!-- .subsubsub -->
<form method="post">
	<table class="form-table">
		<tbody>

			<?php do_action( 'it_exchange_exporter_settings_before' ); ?>

			<tr id="general-settings">
				<td colspan="2" style="padding:0;">
					<h3><?php _e( 'General Settings', 'exchange-addon-exporter' ); ?></h3>
				</td>
			</tr>

			<tr valign="top">
				<th scope="row"><label for="export_filename"><?php _e( 'Export filename', 'exchange-addon-exporter' ); ?></label></th>
				<td>
					<input name="filename" type="text" id="filename" value="<?php echo $filename; ?>" class="regular-text code" />
					<p class="description"><?php _e( 'The filename of the exported export type. Tags can be used: ', 'exchange-addon-exporter' ); ?> <code>%dataset%</code>, <code>%date%</code>, <code>%time%</code>, <code>%store_name%</code>.</p>
				</td>
			</tr>

			<tr>
				<th>
					<label for="delete_temporary_csv"><?php _e( 'Enable archives', 'exchange-addon-exporter' ); ?></label>
				</th>
				<td>
					<select id="delete_csv" name="delete_csv">
						<option value="0"<?php selected( $delete_csv, 0 ); ?>><?php _e( 'Yes', 'exchange-addon-exporter' ); ?></option>
						<option value="1"<?php selected( $delete_csv, 1 ); ?>><?php _e( 'No', 'exchange-addon-exporter' ); ?></option>
					</select>
					<p class="description"><?php _e( 'Save copies of exports to the WordPress Media for downloading later. By default this option is turned on.', 'exchange-addon-exporter' ); ?></p>
				</td>
			</tr>

			<tr>
				<th>
					<label for="encoding"><?php _e( 'Character encoding', 'exchange-addon-exporter' ); ?></label>
				</th>
				<td>
<?php if( $file_encodings ) { ?>
					<select id="encoding" name="encoding">
						<option value=""><?php _e( 'System default', 'exchange-addon-exporter' ); ?></option>
	<?php foreach( $file_encodings as $key => $chr ) { ?>
						<option value="<?php echo $chr; ?>"<?php selected( $chr, $encoding ); ?>><?php echo $chr; ?></option>
	<?php } ?>
					</select>
<?php } else { ?>
					<p class="description"><?php _e( 'Character encoding options are unavailable in PHP 4, contact your hosting provider to update your site install to use PHP 5 or higher.', 'exchange-addon-exporter' ); ?></p>
<?php } ?>
				</td>
			</tr>
<?php if( !ini_get( 'safe_mode' ) ) { ?>
			<tr>
				<th>
					<label for="timeout"><?php _e( 'Script timeout', 'exchange-addon-exporter' ); ?></label>
				</th>
				<td>
					<select id="timeout" name="timeout">
						<option value="600"<?php selected( $timeout, 600 ); ?>><?php printf( __( '%s minutes', 'exchange-addon-exporter' ), 10 ); ?></option>
						<option value="1800"<?php selected( $timeout, 1800 ); ?>><?php printf( __( '%s minutes', 'exchange-addon-exporter' ), 30 ); ?></option>
						<option value="3600"<?php selected( $timeout, 3600 ); ?>><?php printf( __( '%s hour', 'exchange-addon-exporter' ), 1 ); ?></option>
						<option value="0"<?php selected( $timeout, 0 ); ?>><?php _e( 'Unlimited', 'exchange-addon-exporter' ); ?></option>
					</select>
					<p class="description"><?php _e( 'Script timeout defines how long Store Exporter is \'allowed\' to process your CSV file, once the time limit is reached the export process halts.', 'exchange-addon-exporter' ); ?></p>
				</td>
			</tr>
<?php } ?>

			<tr id="csv-settings">
				<td colspan="2" style="padding:0;">
					<hr />
					<h3><?php _e( 'CSV Settings', 'exchange-addon-exporter' ); ?></h3>
				</td>
			</tr>

			<tr>
				<th>
					<label for="delimiter"><?php _e( 'Field delimiter', 'exchange-addon-exporter' ); ?></label>
				</th>
				<td>
					<input type="text" size="3" id="delimiter" name="delimiter" value="<?php echo $delimiter; ?>" maxlength="1" class="text" />
					<p class="description"><?php _e( 'The field delimiter is the character separating each cell in your CSV. This is typically the \',\' (comma) character.', 'exchange-addon-exporter' ); ?></p>
				</td>
			</tr>

			<tr>
				<th>
					<label for="category_separator"><?php _e( 'Category separator', 'exchange-addon-exporter' ); ?></label>
				</th>
				<td>
					<input type="text" size="3" id="category_separator" name="category_separator" value="<?php echo $category_separator; ?>" maxlength="1" class="text" />
					<p class="description"><?php _e( 'The Product Category separator allows you to assign individual Products to multiple Product Categories/Tags/Images at a time. It is suggested to use the \'|\' (vertical pipe) character between each item. For instance: <code>Clothing|Mens|Shirts</code>.', 'exchange-addon-exporter' ); ?></p>
				</td>
			</tr>

			<tr>
				<th>
					<label for="bom"><?php _e( 'Add BOM character', 'exchange-addon-exporter' ); ?></label>
				</th>
				<td>
					<select id="bom" name="bom">
						<option value="1"<?php selected( $bom, 1 ); ?>><?php _e( 'Yes', 'exchange-addon-exporter' ); ?></option>
						<option value="0"<?php selected( $bom, 0 ); ?>><?php _e( 'No', 'exchange-addon-exporter' ); ?></option>
					</select>
					<p class="description"><?php _e( 'Mark the CSV file as UTF8 by adding a byte order mark (BOM) to the export, useful for non-English character sets.', 'exchange-addon-exporter' ); ?></p>
				</td>
			</tr>

			<tr>
				<th>
					<label for="escape_formatting"><?php _e( 'Field escape formatting', 'exchange-addon-exporter' ); ?></label>
				</th>
				<td>
					<label><input type="radio" name="escape_formatting" value="all"<?php checked( $escape_formatting, 'all' ); ?> />&nbsp;<?php _e( 'Escape all fields', 'exchange-addon-exporter' ); ?></label><br />
					<label><input type="radio" name="escape_formatting" value="excel"<?php checked( $escape_formatting, 'excel' ); ?> />&nbsp;<?php _e( 'Escape fields as Excel would', 'exchange-addon-exporter' ); ?></label>
					<p class="description"><?php _e( 'Choose the field escape format that suits your spreadsheet software (e.g. Excel).', 'exchange-addon-exporter' ); ?></p>
				</td>
			</tr>

			<?php do_action( 'it_exchange_exporter_settings_after' ); ?>

		</tbody>
	</table>
	<p class="submit">
		<input type="submit" name="submit" id="submit" class="button button-primary" value="<?php _e( 'Save Changes', 'exchange-addon-exporter' ); ?>" />
	</p>

	<input type="hidden" name="action" value="updated" />
</form>
<?php do_action( 'it_exchange_exporter_settings_bottom' ); ?>